## hyphy 2.5.59+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(HyPhy)
cmake_policy(VERSION 3.0.0)

enable_testing()
#enable_language(Fortran)

set(CMAKE_CONFIGURATION_TYPES Release)

#-------------------------------------------------------------------------------
# OPTIONS
#-------------------------------------------------------------------------------

option(NOAVX OFF)
option(NOSSE4 OFF)
option(NONEON OFF)
option(NOZLIB OFF)

if(CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
   set(NOAVX ON)
   #set(NOSSE4 ON)
   set(NONEON ON)
   set(NOZLIB ON)
   set(LIBRARY_PATH "/hyphy")
   #set(CMAKE_EXECUTABLE_SUFFIX ".html")
   add_definitions (-D_USE_EMSCRIPTEN_)
 endif()

#-------------------------------------------------------------------------------
# SSE MACROS
#-------------------------------------------------------------------------------

macro(PCL_CHECK_FOR_SSE4)
  include(CheckCXXSourceRuns)
  set(CMAKE_REQUIRED_FLAGS)

  #if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANG)
      set(CMAKE_REQUIRED_FLAGS "-msse4.1")
  #endif(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANG)

  check_cxx_source_runs("
      #include <smmintrin.h>
      #include <stdio.h>

      int main ()
      {
          __m128d a, b;
          double vals[2] = {0};
          a = _mm_loadu_pd (vals);
          b = _mm_hadd_pd (a,a);
          _mm_storeu_pd (vals, _mm_blend_pd (a,b,2));
          printf (\"%g\", vals[0]);
          return (0);
      }"
      HAVE_SSE4_EXTENSIONS)
endmacro(PCL_CHECK_FOR_SSE4)

#-------------------------------------------------------------------------------
# NEON MACROS
#-------------------------------------------------------------------------------

macro(PCL_CHECK_FOR_NEON)
	  include(CheckCXXSourceRuns)
	  set(CMAKE_REQUIRED_FLAGS)

	  check_cxx_source_runs("
		#include <stdio.h>
		#include <arm_neon.h>
		int main() {
			double array[4] = {4.,2.,3.,4};
			float64x2_t a1 = vld1q_f64 (array),
						a2 = vld1q_f64 (array+2);
			a1 = vmulq_f64  (a1,a2);
			vst1q_lane_f64 (array, a1, 0);
			printf (\"%g\", array[0]);
			return 0;
	   }"
       HAVE_NEON_EXTENSIONS)
endmacro(PCL_CHECK_FOR_NEON)


#-------------------------------------------------------------------------------
# SSE MACROS
#-------------------------------------------------------------------------------

macro(PCL_CHECK_FOR_AVX)
  include(CheckCXXSourceRuns)
  set(CMAKE_REQUIRED_FLAGS)

  #if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANG)
      set(CMAKE_REQUIRED_FLAGS "-mavx2")
  #endif(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANG)

  check_cxx_source_runs("
      #include <immintrin.h>
      #include <stdio.h>

      int main ()
      {
          __m256d a, b;
          double vals[4] = {0.};
          a = _mm256_loadu2_m128d (vals, vals+2);
          b = _mm256_permute4x64_pd (_mm256_hadd_pd (a,a), 2);
          _mm256_storeu_pd (vals, b);
          printf (\"%g\", vals[0]);
          return (0);
      }"
      HAVE_AVX_EXTENSIONS)
endmacro(PCL_CHECK_FOR_AVX)

#-------------------------------------------------------------------------------
# FMA3 MACROS
#-------------------------------------------------------------------------------

macro(PCL_CHECK_FOR_FMA3)
    include(CheckCXXSourceRuns)
    set(CMAKE_REQUIRED_FLAGS)

    #if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANG)
        set(CMAKE_REQUIRED_FLAGS "-mavx2 -mfma ")
    #endif(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANG)

    check_cxx_source_runs("
    #include <immintrin.h>
    #include <stdio.h>

    int main ()
    {
        __m256d a, b, c;
        double vals[4] = {2.};
        a = _mm256_loadu_pd (vals);
        b = _mm256_loadu_pd (vals);
        c = _mm256_loadu_pd (vals);
        a = _mm256_fmadd_pd      (a, b, c);
        _mm256_storeu_pd (vals, a);
        printf (\"%g\", vals[0]);
        return 0;
    }"
    HAVE_FMA3)
endmacro(PCL_CHECK_FOR_FMA3)


#-------------------------------------------------------------------------------
# set the CMAKE_MODULE_PATH so we can import OpenCL
#-------------------------------------------------------------------------------
set(CMAKE_MODULE_PATH cmake)
set(HYPHY_VERSION 2.1)

#-------------------------------------------------------------------------------
# setup the files we'll be using
#-------------------------------------------------------------------------------
file(GLOB SRC_CORE src/core/*.cpp)
file(GLOB SRC_NEW src/new/*.cpp)
file(GLOB SRC_CONTRIB src/contrib/*.cpp)

set(SRC_LINK src/lib/link/THyPhy.cpp)
set(SRC_SQLITE3 contrib/SQLite-3.8.2/sqlite3.c)
set(SRC_UNIXMAIN src/mains/unix.cpp)
set(SRC_UTILS src/utils/hyphyunixutils.cpp)


set(SRC_COMMON ${SRC_CORE} ${SRC_NEW} ${SRC_SQLITE3} ${SRC_UTILS} ${SRC_CONTRIB})
set_source_files_properties(${SRC_CORE} ${SRC_NEW} {SRC_UTILS} PROPERTIES COMPILE_FLAGS "-Weffc++ -Wextra -Wall")


#-------------------------------------------------------------------------------
# make it fast, scotty
#-------------------------------------------------------------------------------

set(DEFAULT_WARNING_FLAGS " -w -Weffc++ -Wextra -Wall ")
set(DEFAULT_DEBUG_WARNING_FLAGS "-Wall -Wno-int-to-pointer-cast -Wno-conversion-null -Wno-sign-compare")
set(ADDITIONAL_FLAGS "")

if (DEBUGFLAGS)
	set(ADDITIONAL_FLAGS "-g")
endif()


if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
     execute_process(
        COMMAND ${CMAKE_CXX_COMPILER} -dumpversion
        OUTPUT_VARIABLE GCC_VERSION
    )

    if (${GCC_VERSION} VERSION_LESS 4.9)
        message(FATAL_ERROR "Require at least gcc-4.9")
    endif()

    if(${GCC_VERSION} VERSION_LESS 6.0)
      set(DEFAULT_COMPILE_FLAGS "-fsigned-char -O3 -D_FORTIFY_SOURCE=2   -Wall -std=gnu++14")
    else(${GCC_VERSION} VERSION_LESS 6.0)
      set(DEFAULT_COMPILE_FLAGS "-fsigned-char -O3 -D_FORTIFY_SOURCE=2   -Wall -std=c++14")
    endif(${GCC_VERSION} VERSION_LESS 6.0)

    #set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS}  -fopt-info")

    if(NOAVX)
        set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -mno-avx")
        if(NOSSE4)
	        if(NOT CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
            	set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -mno-sse3")
            endif()
        else(NOSSE4)
            PCL_CHECK_FOR_SSE4()
            if(${HAVE_SSE4_EXTENSIONS})
                add_definitions (-D_SLKP_USE_SSE_INTRINSICS)
                set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -msse4.1 ")
                if(CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
				 	set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -msimd128 ")
			    endif()
            endif(${HAVE_SSE4_EXTENSIONS})
        endif(NOSSE4)
    else(NOAVX)
       PCL_CHECK_FOR_AVX()
       if(${HAVE_AVX_EXTENSIONS})
            set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -march=native -mtune=native -mavx2")
            add_definitions (-D_SLKP_USE_AVX_INTRINSICS)
            PCL_CHECK_FOR_FMA3()
            if (${HAVE_FMA3})
                set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS}  -mfma")
                add_definitions (-D_SLKP_USE_FMA3_INTRINSICS)
            endif (${HAVE_FMA3})
        else(${HAVE_AVX_EXTENSIONS})
            PCL_CHECK_FOR_SSE4()
            if(${HAVE_SSE4_EXTENSIONS})
                add_definitions (-D_SLKP_USE_SSE_INTRINSICS)
                set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -msse4.1 ")
                

            endif(${HAVE_SSE4_EXTENSIONS})
        endif(${HAVE_AVX_EXTENSIONS})
    endif(NOAVX)
    	
	if(NOT NONEON)
		PCL_CHECK_FOR_NEON()
		if(${HAVE_NEON_EXTENSIONS})
			add_definitions (-D_SLKP_USE_ARM_NEON)

		endif(${HAVE_NEON_EXTENSIONS})
	endif(NOT NONEON)

    set(DEFAULT_LINK_FLAGS "${DEFAULT_COMPILE_FLAGS}")
endif(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    #set(DEFAULT_COMPILE_FLAGS "-fsigned-char -O3  -fsave-optimization-record=yaml ")
    set(DEFAULT_COMPILE_FLAGS "-fsigned-char -O3 -D_FORTIFY_SOURCE=2  -std=c++14 -Wall")
    if(NOAVX)
        if(NOSSE4)
	        if(NOT CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
            	set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -mno-sse3")
            endif()
         else(NOSSE4)
            PCL_CHECK_FOR_SSE4()
 			if("${HAVE_SSE4_EXTENSIONS}" OR ${CMAKE_SYSTEM_NAME} STREQUAL "Emscripten")
				add_definitions (-D_SLKP_USE_SSE_INTRINSICS)
				set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -msse4.1 ")
				if(CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
					set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -msimd128 ")
				endif()
			endif()  
        endif(NOSSE4)
    else(NOAVX)
        PCL_CHECK_FOR_AVX()
        if(${HAVE_AVX_EXTENSIONS})
            set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -march=native -mtune=native -mavx2")
            add_definitions (-D_SLKP_USE_AVX_INTRINSICS)
            PCL_CHECK_FOR_FMA3()
            if (${HAVE_FMA3})
                set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -mfma")
                add_definitions (-D_SLKP_USE_FMA3_INTRINSICS)
            endif (${HAVE_FMA3})
        else(${HAVE_AVX_EXTENSIONS})
            PCL_CHECK_FOR_SSE4()
            if(${HAVE_SSE4_EXTENSIONS})
                add_definitions (-D_SLKP_USE_SSE_INTRINSICS)
                set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -msse4.1 ")
            endif(${HAVE_SSE4_EXTENSIONS})
        endif (${HAVE_AVX_EXTENSIONS})
    endif(NOAVX)
    
	if(NOT NONEON)
		PCL_CHECK_FOR_NEON()
		if(${HAVE_NEON_EXTENSIONS})
			add_definitions (-D_SLKP_USE_ARM_NEON)
		endif(${HAVE_NEON_EXTENSIONS})
	endif(NOT NONEON)

    set_property(
     SOURCE ${SRC_CORE} ${SRC_NEW} ${SRC_UTILS} ${SRC_UNIXMAIN}
     APPEND_STRING PROPERTY  COMPILE_FLAGS " -std=c++14 "
    )
endif (CMAKE_CXX_COMPILER_ID MATCHES "Clang")

#set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS}  -fopt-info -fopt-info-vec-missed")
set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} ${ADDITIONAL_FLAGS}")

if(NOT DEFINED DEFAULT_COMPILE_FLAGS)
    set(DEFAULT_COMPILE_FLAGS "")
endif(NOT DEFINED DEFAULT_COMPILE_FLAGS)

if(NOT DEFINED DEFAULT_LINK_FLAGS)
    set(DEFAULT_LINK_FLAGS "")
endif(NOT DEFINED DEFAULT_LINK_FLAGS)

set(DEFAULT_LINK_FLAGS "${DEFAULT_LINK_FLAGS}  ${ADDITIONAL_FLAGS}")

if(NOT DEFINED DEFAULT_WARNING_FLAGS)
    set(DEFAULT_WARNING_FLAGS "")
endif(NOT DEFINED DEFAULT_WARNING_FLAGS)

if(CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
   set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -fwasm-exceptions ")
endif()

MESSAGE ("Set compiler flags to ${DEFAULT_COMPILE_FLAGS}")
MESSAGE ("Set linker flags to ${DEFAULT_LINK_FLAGS}")

#-------------------------------------------------------------------------------
# OpenMP support
#-------------------------------------------------------------------------------
find_package(OpenMP)

# emulate missing OpenMP for testing

#set (OPENMP_FOUND FALSE)
#set (OpenMP_CXX_FLAGS "")

#-------------------------------------------------------------------------------
# default installation prefix
#-------------------------------------------------------------------------------
if(NOT DEFINED CMAKE_INSTALL_PREFIX)
    set(CMAKE_INSTALL_PREFIX "/usr/local" CACHE PATH "Installation prefix")
endif()
if(NOT DEFINED INSTALL_PREFIX)
    set(INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX} CACHE INTERNAL "Installation prefix" FORCE)
endif()

if(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
	set(DEFAULT_LIBRARIES )
else(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
    set(DEFAULT_LIBRARIES dl)
endif(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")

#-------------------------------------------------------------------------------
# LIBCurl support
#-------------------------------------------------------------------------------
find_package(CURL)
if(${CURL_FOUND})
    message(${CURL_LIBRARIES})
    list(APPEND DEFAULT_LIBRARIES ${CURL_LIBRARIES})
    add_definitions (-D__HYPHYCURL__)
endif(${CURL_FOUND})

if(NOT NOZLIB)

=== debian/changelog ===
hyphy (2.5.59+dfsg-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:57:57 +1100

hyphy (2.5.59+dfsg-1build2) noble; urgency=medium

  * No-change rebuild against libcurl3t64-gnutls

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 06:59:43 +0000

hyphy (2.5.59+dfsg-1build1) noble; urgency=medium

  * No-change rebuild against libopenmpi3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 18:26:58 +0000

hyphy (2.5.59+dfsg-1) unstable; urgency=medium

  * New upstream version

 -- Étienne Mollier <emollier@debian.org>  Sat, 13 Jan 2024 17:00:01 +0100

## hyphy 2.5.60+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.12)
 project(HyPhy)
-cmake_policy(VERSION 3.0.0)
+#cmake_policy(VERSION 3.0.0)
 
 enable_testing()
 #enable_language(Fortran)
@@ -316,6 +316,11 @@
 MESSAGE ("Set compiler flags to ${DEFAULT_COMPILE_FLAGS}")
 MESSAGE ("Set linker flags to ${DEFAULT_LINK_FLAGS}")
 
+set(BLA_VENDOR Apple)
+find_package(BLAS)
+
+
+
 #-------------------------------------------------------------------------------
 # OpenMP support
 #-------------------------------------------------------------------------------
@@ -349,7 +354,3 @@
 if(${CURL_FOUND})
     message(${CURL_LIBRARIES})
     list(APPEND DEFAULT_LIBRARIES ${CURL_LIBRARIES})
-    add_definitions (-D__HYPHYCURL__)
-endif(${CURL_FOUND})
-
-if(NOT NOZLIB)

=== debian/changelog ===
hyphy (2.5.60+dfsg-1) unstable; urgency=medium

  * New upstream version 2.5.60+dfsg
  * Unfuzz all patches.
  * d/control: migrate build-dep to pkgconf.

 -- Étienne Mollier <emollier@debian.org>  Sun, 10 Mar 2024 12:37:20 +0100

=== debian/control ===
Source: hyphy
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Étienne Mollier <emollier@debian.org>,
           Nilesh Patra <nilesh@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               mpi-default-dev,
               libcurl4-gnutls-dev | libcurl4-dev,
               libssl-dev,
               libsqlite3-dev,
               pkgconf,
               libpython3-all-dev,
               python3-all-dev:any,
               chrpath
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/hyphy
Vcs-Git: https://salsa.debian.org/med-team/hyphy.git
Homepage: https://hyphy.org/
Rules-Requires-Root: no

Package: hyphy-pt
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         hyphy-common (= ${source:Version})
Description: Hypothesis testing using Phylogenies (pthreads version)
 HyPhy is an open-source software package for the analysis of genetic
 sequences using techniques in phylogenetics, molecular evolution, and
 machine learning. It features a complete graphical user interface (GUI)
 and a rich scripting language for limitless customization of analyses.
 Additionally, HyPhy features support for parallel computing environments
 (via message passing interface) and it can be compiled as a shared
 library and called from other programming environments such as Python or
 R.  Continued development of HyPhy is currently supported in part by an
 NIGMS R01 award 1R01GM093939.
 .
 This package provides an executable using pthreads to do multiprocessing.

Package: hyphy-mpi
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         hyphy-common (= ${source:Version})
Description: Hypothesis testing using Phylogenies (MPI version)
 HyPhy is an open-source software package for the analysis of genetic
 sequences using techniques in phylogenetics, molecular evolution, and
 machine learning. It features a complete graphical user interface (GUI)
 and a rich scripting language for limitless customization of analyses.
 Additionally, HyPhy features support for parallel computing environments
 (via message passing interface) and it can be compiled as a shared
 library and called from other programming environments such as Python or
 R.  Continued development of HyPhy is currently supported in part by an
 NIGMS R01 award 1R01GM093939.
 .
 This package provides an executable using MPI to do multiprocessing.

Package: hyphy-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: hyphy-mpi | hyphy-pt
Description: Hypothesis testing using Phylogenies (common files)
 HyPhy is an open-source software package for the analysis of genetic
 sequences using techniques in phylogenetics, molecular evolution, and
 machine learning. It features a complete graphical user interface (GUI)
 and a rich scripting language for limitless customization of analyses.
 Additionally, HyPhy features support for parallel computing environments
 (via message passing interface) and it can be compiled as a shared
 library and called from other programming environments such as Python or
 R.  Continued development of HyPhy is currently supported in part by an
 NIGMS R01 award 1R01GM093939.
 .
 This package provides files that are common to all binary versions.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
export LC_ALL=C.UTF-8

include /usr/share/dpkg/default.mk

DTMP := $(CURDIR)/debian/tmp

# a few ISO-8859-1 files needing conversion to UTF-8
ISOFILES  = $(DTMP)/usr/share/hyphy/TemplateBatchFiles/PARRIS.bf
ISOFILES += $(DTMP)/usr/share/hyphy/TemplateBatchFiles/TemplateModels/MEC.mdl
ISOFILES += $(DTMP)/usr/share/hyphy/TemplateBatchFiles/TemplateModels/models.lst

%:
	dh $@ --buildsystem=cmake

override_dh_auto_clean:
ifeq (amd64,$(DEB_HOST_ARCH))
	dh_auto_clean --builddirectory obj-avx
	dh_auto_clean --builddirectory obj-sse3
endif
	dh_auto_clean

override_dh_auto_configure:
ifeq (amd64,$(DEB_HOST_ARCH))
	dh_auto_configure -- -DINSTALL_PREFIX=/usr -DNOAVX=ON -DNOSSE3=ON
	dh_auto_configure --builddirectory obj-avx -- -DINSTALL_PREFIX=/usr -DNOAVX=OFF -DNOSSE3=OFF
	dh_auto_configure --builddirectory obj-sse3 -- -DINSTALL_PREFIX=/usr -DNOAVX=ON -DNOSSE3=OFF
else
	dh_auto_configure -- -DINSTALL_PREFIX=/usr -DNOAVX=ON -DNOSSE3=ON
endif

override_dh_auto_build:
ifeq (amd64,$(DEB_HOST_ARCH))
	dh_auto_build -- MP MPI
	dh_auto_build --builddirectory obj-avx -- MP MPI
	dh_auto_build --builddirectory obj-sse3 -- MP MPI
else
	dh_auto_build -- MP MPI
endif

override_dh_install-arch:
	# convert a few ISO-8859-1 files to address national-encoding
	set -e \
	; for file in $(ISOFILES) \
	; do    iconv -f ISO-8859-1 -t UTF-8 < "$${file}" > "$${file}.new" \
	;       mv -v "$${file}.new" "$${file}" \
	; done
	dh_install -a
	chrpath --delete obj-*/HYPHYMPI
ifeq (amd64,$(DEB_HOST_ARCH))
	mkdir -p debian/hyphy-mpi/usr/lib/$(DEB_SOURCE)/bin
	mkdir -p debian/hyphy-pt/usr/lib/$(DEB_SOURCE)/bin
	cp obj-avx/HYPHYMPI debian/hyphy-mpi/usr/lib/$(DEB_SOURCE)/bin/HYPHYMPI-avx
	cp obj-sse3/HYPHYMPI debian/hyphy-mpi/usr/lib/$(DEB_SOURCE)/bin/HYPHYMPI-sse3
	cp obj-avx/hyphy debian/hyphy-pt/usr/lib/$(DEB_SOURCE)/bin/hyphy-avx
	cp obj-sse3/hyphy debian/hyphy-pt/usr/lib/$(DEB_SOURCE)/bin/hyphy-sse3
	mv debian/hyphy-mpi/usr/bin/HYPHYMPI debian/hyphy-mpi/usr/lib/$(DEB_SOURCE)/bin/
	mv debian/hyphy-pt/usr/bin/hyphy debian/hyphy-pt/usr/lib/$(DEB_SOURCE)/bin/
	cd $(CURDIR)/debian/hyphy-mpi/usr/bin && \
		ln -s ../lib/$(DEB_SOURCE)/bin/simd-dispatch HYPHYMPI
	cd $(CURDIR)/debian/hyphy-pt/usr/bin && \
		ln -s ../lib/$(DEB_SOURCE)/bin/simd-dispatch hyphy
endif

override_dh_install-indep:
	dh_install -i
ifeq (amd64,$(DEB_HOST_ARCH))
	dh_install -phyphy-common debian/bin/simd-dispatch /usr/lib/$(DEB_SOURCE)/bin
endif

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifeq (amd64,$(DEB_HOST_ARCH))
	set -e ; for SIMD in avx sse3 ; do \
		if lscpu | grep -q $${SIMD} ; then \
			find "obj-$${SIMD}/" \
			-not -path "*/CMakeFiles/*" \
			-type f,l \
			-executable \
			-exec cp -v '{}' . \; && \
			./run_unit_tests.sh ; \
		fi ; \
	done
endif
	find "obj-$(DEB_HOST_GNU_TYPE)/" \
		-not -path "*/CMakeFiles/*" \
		-type f,l \
		-executable \
		-exec cp -v '{}' . \;
	./run_unit_tests.sh
endif

override_dh_installdocs-arch:
	dh_installdocs -a
	for news in debian/NEWS.Debian.* ; do \
	    pkg=`echo $${news} | sed 's/.*NEWS.Debian.//'` ; \
	    cp -a $${news} debian/$${pkg}/usr/share/doc/$${pkg}/NEWS.Debian ; \
	done

override_dh_installdocs-indep:
	dh_installdocs -i

## hyphy 2.5.62+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,6 +15,7 @@
 option(NOSSE4 OFF)
 option(NONEON OFF)
 option(NOZLIB OFF)
+option(NOBLAS OFF)
 
 if(CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
    set(NOAVX ON)

=== debian/changelog ===
hyphy (2.5.62+dfsg-1build1) oracular; urgency=medium

  * No-change rebuild against mpi-defaults 1.17

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Tue, 30 Jul 2024 13:56:30 -0700

hyphy (2.5.62+dfsg-1) unstable; urgency=medium

  * New upstream version 2.5.62+dfsg
  * d/control: declare compliance to standards version 4.7.0.
  * Unfuzz all patches.
  * d/copyright: delete reference to */.DS_Store: not distributed anymore.

 -- Étienne Mollier <emollier@debian.org>  Sun, 02 Jun 2024 10:41:46 +0200

## hyphy 2.5.63+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -236,7 +236,7 @@
 		PCL_CHECK_FOR_NEON()
 		if(${HAVE_NEON_EXTENSIONS})
 			add_definitions (-D_SLKP_USE_ARM_NEON)
-
+			set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -mcpu=native -mtune=native ")
 		endif(${HAVE_NEON_EXTENSIONS})
 	endif(NOT NONEON)
 
@@ -284,6 +284,8 @@
 		PCL_CHECK_FOR_NEON()
 		if(${HAVE_NEON_EXTENSIONS})
 			add_definitions (-D_SLKP_USE_ARM_NEON)
+			set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -mcpu=native -mtune=native ")
+
 		endif(${HAVE_NEON_EXTENSIONS})
 	endif(NOT NONEON)
 
@@ -350,8 +352,3 @@
 
 #-------------------------------------------------------------------------------
 # LIBCurl support
-#-------------------------------------------------------------------------------
-find_package(CURL)
-if(${CURL_FOUND})
-    message(${CURL_LIBRARIES})
-    list(APPEND DEFAULT_LIBRARIES ${CURL_LIBRARIES})

=== debian/changelog ===
hyphy (2.5.63+dfsg-1build2) plucky; urgency=medium

  * No-change rebuild for openmpi soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 30 Nov 2024 07:13:21 +0100

hyphy (2.5.63+dfsg-1build1) plucky; urgency=medium

  * SRU: #2083480: No-change rebuild to add support for Python 3.13.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 13 Nov 2024 10:00:59 +0100

hyphy (2.5.63+dfsg-1) unstable; urgency=medium

  * New upstream version 2.5.63+dfsg
  * set-zlib-after-setting-default-libs.patch: unfuzz.
  * use_debian_sqlite.patch: unfuzz.
  * d/rules: locate all HYPHYMPI to erase DT_RUNPATH.

 -- Étienne Mollier <emollier@debian.org>  Sun, 03 Nov 2024 11:54:22 +0100

## hyphy 2.5.68+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,7 @@
 #enable_language(Fortran)
 
 set(CMAKE_CONFIGURATION_TYPES Release)
+
 
 #-------------------------------------------------------------------------------
 # OPTIONS
@@ -170,11 +171,13 @@
 
 set(DEFAULT_WARNING_FLAGS " -w -Weffc++ -Wextra -Wall ")
 set(DEFAULT_DEBUG_WARNING_FLAGS "-Wall -Wno-int-to-pointer-cast -Wno-conversion-null -Wno-sign-compare")
-set(ADDITIONAL_FLAGS "")
+set(ADDITIONAL_FLAGS "-g")
 
 if (DEBUGFLAGS)
 	set(ADDITIONAL_FLAGS "-g")
 endif()
+
+#include_directories("/Library/Developer/CommandLineTools/SDKs/MacOSX15.2.sdk/usr/include/c++/v1")
 
 
 if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
@@ -350,5 +353,3 @@
     set(DEFAULT_LIBRARIES dl)
 endif(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
 
-#-------------------------------------------------------------------------------
-# LIBCurl support

=== debian/changelog ===
hyphy (2.5.68+dfsg-1) unstable; urgency=medium

  * New upstream version 2.5.68+dfsg
  * d/patches/*: unfuzz all patches.

 -- Étienne Mollier <emollier@debian.org>  Sat, 15 Feb 2025 19:20:03 +0100

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
                libpython3-all-dev,
                python3-all-dev:any,
                chrpath
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/med-team/hyphy
 Vcs-Git: https://salsa.debian.org/med-team/hyphy.git
 Homepage: https://hyphy.org/

=== debian/rules ===
--- 
+++ 
@@ -50,7 +50,7 @@
 	;       mv -v "$${file}.new" "$${file}" \
 	; done
 	dh_install -a
-	chrpath --delete obj-*/HYPHYMPI
+	find -type f -name HYPHYMPI -exec chrpath --delete '{}' ';'
 ifeq (amd64,$(DEB_HOST_ARCH))
 	mkdir -p debian/hyphy-mpi/usr/lib/$(DEB_SOURCE)/bin
 	mkdir -p debian/hyphy-pt/usr/lib/$(DEB_SOURCE)/bin

## hyphy 2.5.69+dfsg

=== debian/changelog ===
hyphy (2.5.69+dfsg-2) unstable; urgency=medium

  * Team Upload.
  * Drop myself from uploaders
  * Drop Redundant "Rules-Requires-Root: no"
  * Fixup old-fsf-address-in-copyright-file
  * Move d/watch to version 5

 -- Nilesh Patra <nilesh@debian.org>  Sun, 02 Nov 2025 20:27:03 +0530

hyphy (2.5.69+dfsg-1) unstable; urgency=medium

  * New upstream version 2.5.69+dfsg (no changes).
  * rm_arch_specific_flags.patch: update to include NEON variants.
    This is needed to fix illegal instruction errors seen in autopkgtest.
  * d/rules: leave a note to build NEON SIMDe variants.
  * d/control: declare compliance to standards version 4.7.2.

 -- Étienne Mollier <emollier@debian.org>  Wed, 05 Mar 2025 12:43:12 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,6 @@
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Andreas Tille <tille@debian.org>,
            Étienne Mollier <emollier@debian.org>,
-           Nilesh Patra <nilesh@debian.org>
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
@@ -15,11 +14,10 @@
                libpython3-all-dev,
                python3-all-dev:any,
                chrpath
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/hyphy
 Vcs-Git: https://salsa.debian.org/med-team/hyphy.git
 Homepage: https://hyphy.org/
-Rules-Requires-Root: no
 
 Package: hyphy-pt
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -16,6 +16,8 @@
 
 %:
 	dh $@ --buildsystem=cmake
+
+# FIXME: build NEON SIMDe variants for Aarch64.
 
 override_dh_auto_clean:
 ifeq (amd64,$(DEB_HOST_ARCH))

=== debian/watch ===
Version: 5

Template: Github
Owner: veg
Project: hyphy
Repacksuffix: +dfsg
Dversion-Mangle: s/\+dfsg//g
